//+------------------------------------------------------------------+
// _TRO_FibProj
//+------------------------------------------------------------------+

#property indicator_chart_window 

#property indicator_buffers 7

#property indicator_color1 OrangeRed 
#property indicator_color2 Orange
#property indicator_color3 Yellow 
#property indicator_color4 White
#property indicator_color5 Yellow
#property indicator_color6 Orange
#property indicator_color7 OrangeRed

//---- For the small screens
//extern string    Display_infos         = "=== If true, displayed on the chart ===";
//extern bool      display_on_chart      =  true ;  // If true, the open trade analysis, daily pivots and daily range will be displayed on the chart window

extern int myPeriod  = NULL ;
extern int myChartY = 168 ;
extern int myStyle  = 2 ;

// indicators parameters


//---- buffers
double P1Buffer[];
double P2Buffer[];
double P3Buffer[];
double P4Buffer[];
double P5Buffer[];
double P6Buffer[];
double P7Buffer[];


//int myPeriod = PERIOD_D1;

int TimeZone=0;
bool pivots = true;
bool alert = true;

double yesterday_high=0;
double yesterday_open=0;
double yesterday_low=0;
double yesterday_close=0;
double today_open=0;
double today_high=0;
double today_low=0;


double rates_h1[2][6];
double rates_d1[2][6];

double Q,H,L,F;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- name for indicator window

   string short_name=" ";
   IndicatorShortName(short_name);
   SetIndexBuffer(0, P1Buffer);
   SetIndexBuffer(1, P2Buffer);
   SetIndexBuffer(2, P3Buffer);
   SetIndexBuffer(3, P4Buffer);
   SetIndexBuffer(4, P5Buffer);
   SetIndexBuffer(5, P6Buffer);
   SetIndexBuffer(6, P7Buffer);
//----
   SetIndexStyle(0, DRAW_LINE, myStyle, 1);
   SetIndexStyle(1, DRAW_LINE, myStyle, 1);   
   SetIndexStyle(2, DRAW_LINE, myStyle, 1);
   SetIndexStyle(3, DRAW_LINE, myStyle, 1);
   SetIndexStyle(4, DRAW_LINE, myStyle, 1);
   SetIndexStyle(5, DRAW_LINE, myStyle, 1);
   SetIndexStyle(6, DRAW_LINE, myStyle, 1);   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   
   ObjectDelete("pivots");
   ObjectDelete("line5");
   ObjectDelete("R3_Label");
   ObjectDelete("R3_Value");
   ObjectDelete("R2_Label");
   ObjectDelete("R2_Value");
   ObjectDelete("R1_Label");
   ObjectDelete("R1_Value");
   ObjectDelete("Pivot_Label");
   ObjectDelete("Pivot_Value");
   ObjectDelete("S1_Label");
   ObjectDelete("S1_Value");
   ObjectDelete("S2_Label");
   ObjectDelete("S2_Value");
   ObjectDelete("S3_Label");
   ObjectDelete("S3_Value");

   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

  int j,total=OrdersTotal();
   for(j=0;j<total;j++)
   {
    OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
   }
   
   color color_common_line = White;
   color color_common_text = White;
   color color_ind = PowderBlue;
   color color_indic;
   color color_pivots_1=Orchid;
   double x;
  
   int i, dayi, counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;  
   int limit = Bars - counted_bars;
//----   
   for(i = limit - 1; i >= 0; i--)
     {
       dayi = iBarShift(Symbol(), myPeriod, Time[i], false);
//   int dayi = iBarShift(Symbol(), myPeriod, Time[0], false);
 
   double yesterday_high  = iHigh(Symbol(), myPeriod,dayi + 1);
   double yesterday_low   = iLow(Symbol(), myPeriod,dayi + 1);
   double yesterday_close = iClose(Symbol(), myPeriod,dayi + 1);
   double day_high        = iHigh(Symbol(), myPeriod,dayi);
   double day_low         = iLow(Symbol(), myPeriod,dayi );
   double day_close       = iClose(Symbol(), myPeriod,dayi ); 

	double xRange = (yesterday_high - yesterday_low) ;
		
	double R3 = yesterday_high+(xRange *0.618) ; 	// fib PR2 .618	
   double R2 = yesterday_high+(xRange *0.382) ; 	// fib PR1 .382
   double R1 = yesterday_high ;	// high 1.00
   double P =  yesterday_low + (xRange * 0.50 ) ; // fib .50	
   double S1 = yesterday_low ; // low 0.00	
   double S2 = yesterday_low - (xRange * 0.382 ) ; // fib 382	
	double S3 = yesterday_low - (xRange * 0.618 ) ; // fib 618
	
	P1Buffer[i] = R3 ;
	P2Buffer[i] = R2 ;
   P3Buffer[i] = R1 ;
	P4Buffer[i] = P ;
	P5Buffer[i] = S1 ;
   P6Buffer[i] = S2 ;
   P7Buffer[i] = S3 ;
    }
    
   color color_r3=Red;
   color color_r2=Red;
   color color_r1=Red;
   color color_p =Red;
   color color_s1=Red;
   color color_s2=Red;
   color color_s3=Red;  
   	
	if( day_close < R3) { color_r3=Lime; } 
	if( day_close < R2) { color_r2=Lime; } 	
	if( day_close < R1) { color_r1=Lime; } 
	if( day_close < P ) { color_p=Lime; } 
	if( day_close < S1) { color_s1=Lime; } 	
	if( day_close < S2) { color_s2=Lime; }		
	if( day_close < S3) { color_s3=Lime; }		
		
	int Precision, dig;	

   if( StringFind( Symbol(), "JPY", 0) != -1 ) { Precision = 100; dig = 2;}
   else                                        { Precision = 10000; dig = 4; }

 
 
int sPeriod= Period();

if (myPeriod != NULL){ sPeriod= myPeriod ;}
   
     	
//---- Set Pivots labels

   int WindowToUse;
   int Corner_line, Xdist_line;
   int Corner_text, Corner_value, Xdist_text, Xdist_value;
   int Ydist_line5;
   int Corner_pivots, Xdist_pivots, Ydist_pivots;
   int Ydist_R3, Ydist_R2, Ydist_R1, Ydist_PV, Ydist_S1, Ydist_S2, Ydist_S3;
  
   int YdistInc ;
    WindowToUse =  0;
    Corner_line = 1;
    Corner_text = 1; Corner_value = 1;
    Xdist_line = 21; Xdist_text = 93; Xdist_value = 23;
    Corner_pivots = 1; Xdist_pivots = 21; 
    Ydist_pivots = myChartY;  
    Ydist_line5 = Ydist_pivots + 11; YdistInc = 15 ;
    Ydist_R3 = Ydist_pivots + 25; 
    Ydist_R2 = Ydist_R3 + YdistInc; 
    Ydist_R1 = Ydist_R3 + YdistInc*2; 
    Ydist_PV = Ydist_R3 + YdistInc*3; 
    Ydist_S1 = Ydist_R3 + YdistInc*4; 
    Ydist_S2 = Ydist_R3 + YdistInc*5; 
    Ydist_S3 = Ydist_R3 + YdistInc*6;

   ObjectCreate("pivots", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("pivots",sPeriod + " Fib Proj+",9, "Verdana", color_pivots_1);
   ObjectSet("pivots", OBJPROP_CORNER, Corner_pivots);
   ObjectSet("pivots", OBJPROP_XDISTANCE, Xdist_pivots);
   ObjectSet("pivots", OBJPROP_YDISTANCE, Ydist_pivots);
   
   ObjectCreate("line5", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("line5","---------------------",7, "Verdana", color_pivots_1);
   ObjectSet("line5", OBJPROP_CORNER, Corner_line);
   ObjectSet("line5", OBJPROP_XDISTANCE, Xdist_line);
   ObjectSet("line5", OBJPROP_YDISTANCE, Ydist_line5);
   
   ObjectCreate("R3_Label", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("R3_Label","+618",9, "Verdana", OrangeRed);
   ObjectSet("R3_Label", OBJPROP_CORNER, Corner_text);
   ObjectSet("R3_Label", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("R3_Label", OBJPROP_YDISTANCE, Ydist_R3);
   
   ObjectCreate("R3_Value", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("R3_Value"," "+DoubleToStr(R3,dig),9, "Verdana", color_r3);
   ObjectSet("R3_Value", OBJPROP_CORNER, Corner_value);
   ObjectSet("R3_Value", OBJPROP_XDISTANCE, Xdist_value);
   ObjectSet("R3_Value", OBJPROP_YDISTANCE, Ydist_R3);
   
   ObjectCreate("R2_Label", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("R2_Label","+382",9, "Verdana", Orange);
   ObjectSet("R2_Label", OBJPROP_CORNER, Corner_text);
   ObjectSet("R2_Label", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("R2_Label", OBJPROP_YDISTANCE, Ydist_R2);
   
   ObjectCreate("R2_Value", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("R2_Value"," "+DoubleToStr(R2,dig),9, "Verdana", color_r2);
   ObjectSet("R2_Value", OBJPROP_CORNER, Corner_value);
   ObjectSet("R2_Value", OBJPROP_XDISTANCE, Xdist_value);
   ObjectSet("R2_Value", OBJPROP_YDISTANCE, Ydist_R2);
   
   ObjectCreate("R1_Label", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("R1_Label","High",9, "Verdana", Yellow );
   ObjectSet("R1_Label", OBJPROP_CORNER, Corner_text);
   ObjectSet("R1_Label", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("R1_Label", OBJPROP_YDISTANCE, Ydist_R1);
   
   ObjectCreate("R1_Value", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("R1_Value"," "+DoubleToStr(R1,dig),9, "Verdana", color_r1);
   ObjectSet("R1_Value", OBJPROP_CORNER, Corner_value);
   ObjectSet("R1_Value", OBJPROP_XDISTANCE, Xdist_value);
   ObjectSet("R1_Value", OBJPROP_YDISTANCE, Ydist_R1);
   
   ObjectCreate("Pivot_Label", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("Pivot_Label","Mid",9, "Verdana", White);
   ObjectSet("Pivot_Label", OBJPROP_CORNER, Corner_text);
   ObjectSet("Pivot_Label", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("Pivot_Label", OBJPROP_YDISTANCE, Ydist_PV);
   
   ObjectCreate("Pivot_Value", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("Pivot_Value"," "+DoubleToStr(P,dig),9, "Verdana", color_p);
   ObjectSet("Pivot_Value", OBJPROP_CORNER, Corner_value);
   ObjectSet("Pivot_Value", OBJPROP_XDISTANCE, Xdist_value);
   ObjectSet("Pivot_Value", OBJPROP_YDISTANCE, Ydist_PV);
   
   ObjectCreate("S1_Label", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("S1_Label","Low",9, "Verdana", Yellow);
   ObjectSet("S1_Label", OBJPROP_CORNER, Corner_text);
   ObjectSet("S1_Label", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("S1_Label", OBJPROP_YDISTANCE, Ydist_S1);
   
   ObjectCreate("S1_Value", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("S1_Value"," "+DoubleToStr(S1,dig),9, "Verdana", color_s1);
   ObjectSet("S1_Value", OBJPROP_CORNER, Corner_value);
   ObjectSet("S1_Value", OBJPROP_XDISTANCE, Xdist_value);
   ObjectSet("S1_Value", OBJPROP_YDISTANCE, Ydist_S1);
   
   ObjectCreate("S2_Label", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("S2_Label","-.382",9, "Verdana", Orange);
   ObjectSet("S2_Label", OBJPROP_CORNER, Corner_text);
   ObjectSet("S2_Label", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("S2_Label", OBJPROP_YDISTANCE, Ydist_S2);
   
   ObjectCreate("S2_Value", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("S2_Value"," "+DoubleToStr(S2,dig),9, "Verdana", color_s2);
   ObjectSet("S2_Value", OBJPROP_CORNER, Corner_value);
   ObjectSet("S2_Value", OBJPROP_XDISTANCE, Xdist_value);
   ObjectSet("S2_Value", OBJPROP_YDISTANCE, Ydist_S2);
   
   ObjectCreate("S3_Label", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("S3_Label","-.618",9, "Verdana", OrangeRed);
   ObjectSet("S3_Label", OBJPROP_CORNER, Corner_text);
   ObjectSet("S3_Label", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("S3_Label", OBJPROP_YDISTANCE, Ydist_S3);
   
   ObjectCreate("S3_Value", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("S3_Value"," "+DoubleToStr(S3,dig),9, "Verdana", color_s3);
   ObjectSet("S3_Value", OBJPROP_CORNER, Corner_value);
   ObjectSet("S3_Value", OBJPROP_XDISTANCE, Xdist_value);
   ObjectSet("S3_Value", OBJPROP_YDISTANCE, Ydist_S3);
   
   
   
   
   return(0);
  }